#include "Types.h"

bool Node::operator == (const Node& A) const {
    if (ID == A.ID && x == A.x && y == A.y &&
        z == A.z && flag == A.flag)
        return true;
    else return false;
};

std::ostream& operator << (std::ostream& out, const Node& A) {
    out << std::setw(4) << A.ID << " |"
        << std::right << std::setw(11) << A.x << std::setw(11) << A.y << std::setw(11) << A.z
        << " | " << A.flag << "\n";
    return out;
}

std::ostream& operator << (std::ostream& out, const FiniteElement& A) {
    out << std::setw(4) << A.FE_ID << " |"
        << std::setw(11) << A.material_ID << " |";
    for (const auto& it : A.nodes_ID)
        out << std::right << std::setw(4) << it;
    out << "\n";
    return out;
}

std::ostream& operator << (std::ostream& out, const BoundaryFiniteElement& A) {
    out << std::setw(9) << A.BFE_ID << " |"
        << std::setw(9) << A.border_ID << " |";
    for (const auto& it : A.nodes_ID)
        out << std::right << std::setw(4) << it;
    out << "\n";
    return out;
}

std::ostream& operator << (std::ostream& out, const std::vector<Node>& A) {
    out << A.size() << (A.size() > 1 ? " Nodes:\n" : " Node:\n") << " ID"
        << std::setw(10) << "X" << std::setw(11) << "Y" << std::setw(11) << "Z" << std::setw(14) << "Vertex\n";
    for (const auto& it : A)
        out << it;
    return out;
}


std::ostream& operator << (std::ostream& out, const std::vector<FiniteElement>& A) {
    int elements_size = A.size();
    out << elements_size << (elements_size > 1 ? " Elements:\n" : " Element:\n")
        << " ID" << std::setw(15) << "Material_ID" << std::setw(15) << "Nodes ID\n";
    for (const auto& it : A)
        out << it;
    return out;
}

std::ostream& operator << (std::ostream& out, const std::vector<BoundaryFiniteElement>& A) {
    int size = A.size();
    out << size << (size > 1 ? " Surfaces:\n" : " Surface:\n")
        << "Surface_ID" << std::setw(11) << "Border_ID" << std::setw(14) << "Nodes ID\n";
    for (const auto& it : A)
        out << it;
    return out;
}

bool Edge::operator == (const Edge& A) const {
    if (A.first_node_ID == first_node_ID && A.last_node_ID == last_node_ID)
        return true;
    else if (A.first_node_ID == last_node_ID && A.last_node_ID == first_node_ID)
        return true;
    else return false;
}